(in-package :araneida)

(defun serve-event-http-listener-accept-one-request (listener)
  (with-accept-flets 
      (let ((sb-impl::*descriptor-handlers*  nil)
	    (s (accept listener)))
	(unwind-protect
	     (do-it listener s)
	  (forcibly-close-stream s)))))

(defmethod start-listening ((listener serve-event-http-listener)
			    &key &allow-other-keys)
  (let ((socket
	 (make-instance 'inet-socket :type :stream :protocol :tcp)))
    (setf (sockopt-reuse-address socket) t)
    (socket-bind socket (http-listener-address listener)
		 (http-listener-port listener))
    (socket-listen socket 15)
    (setf (http-listener-socket listener) socket)
    (setf (http-listener-serve-event listener)
	  (sb-sys:add-fd-handler 
	   (socket-file-descriptor socket)
	   :input 
	   (lambda (fd)
	     (declare (ignore fd))
	     (serve-event-http-listener-accept-one-request listener))))))

(defmethod stop-listening ((listener serve-event-http-listener)
			   &key abort &allow-other-keys)
  (declare (ignore abort))		;FIXME we always abort.  not very nice
  (sb-sys:remove-fd-handler (http-listener-serve-event listener))
  (socket-close (http-listener-socket listener)))
    

